#include"printnet.H"
#include"dimensions.H"
#include"net.H"
#include"symboltab.H"
#include"graph.H"
#include"symm.H"
#include"stubborn.H"
#include"formula.H"
#include"check.H"
#include"path.H"
#include<fstream.h>
#include<iostream.h>
#include<ctype.h>
#include<stdlib.h>
#include<stdio.h>
#include<new.h>

Place ** Places;
Place * CheckPlace = (Place *) 0;
Transition * CheckTransition = (Transition *) 0;
Transition ** Transitions;
unsigned int Edges;
unsigned int Arc::cnt = 0;
unsigned int Place::hash_value = 0;
unsigned int Transition::cnt = 0;
#ifdef STUBBORN
unsigned int Transition::NrStubborn = 0;
Transition * Transition::TarjanStack = (Transition *) 0;
Transition * Transition::CallStack = (Transition *) 0;
#endif
Transition * LastAttractor; // Last transition in static attractor sets
unsigned int Transition::NrEnabled = 0;
Transition * Transition::StartOfEnabledList = (Transition *) 0;
#ifdef EXTENDED
Transition * Transition::StartOfIgnoredList = (Transition *) 0;
#endif
#ifdef STUBBORN
Transition * Transition::StartOfStubbornList = (Transition *) 0;
Transition * Transition::EndOfStubbornList = (Transition *) 0;
#endif

  char * lownetfile;
  char * netfile;
  char * analysefile;
  char * graphfile;
  char * pathfile;
  char * statefile;
  char * symmfile;
  char * netbasename;

  bool Nflg, nflg, Aflg, Sflg, Yflg, Pflg,GMflg, aflg, sflg, yflg,pflg,gmflg;
  char graphformat;

int garbagefound = 0;
char * reserve;
inline void garbagecollection()
{
}

void myown_newhandler()
{
		delete reserve;
		throw overflow();
}


unsigned int Place::cnt = 0;
void readnet();
void removeisolated();
unsigned int NonEmptyHash;
int main(int argc, char ** argv){
  unsigned int i,h;
  // 0. eigenen New-Handler installieren
  try {
  set_new_handler(&myown_newhandler);
  reserve = new char[10000];
  garbagefound = 0;
  // 1. Fileoptionen holen und auswerten
  
  // Options:
  // File without option: Input net (stdin if not specified)
  // -n [file] output file for LL net
  // -a [file] detailed spec. of analysis task (target marking/place/transtion/
  //                                             /formula)
  // -s [file] output file for witness state
  // -y [file] output file for symmetry group generating set
  // -p [file] output file for witness path
  // -[gm] [file] output file for graph -g only state number and transitions
  //									 -m markings and transitions
  // if [file] is omitted, the following standard names are used:
  // (<base> refers to the net file name without extension)
  // -a: <base>.task
  // -s: <base>.state
  // -y: <base>.symm
  // -p: <base>.path
  // -[gm]: <base>.graph
  // Using corresponding capital letters refers to output to the
  // standard output stream. Output to stdout will also happen if
  // an output file cannot be opened.
  // if no net file is specified, net is read from stdin, and
  // <base> is set to "unknown_net"

  Nflg = nflg = Aflg = Sflg = Yflg = Pflg = GMflg = aflg = sflg = yflg = pflg = gmflg = false;
  lownetfile = netfile = analysefile = graphfile = pathfile = statefile = symmfile = 
  netbasename = (char *) 0;
  graphformat = '\0';
  for(i = 1; i < argc; i++)
  {
	char * file;
	file = (char *) 0;
	if(argv[i][0] == '-')
	{
		// option
		switch(argv[i][1])
		{
		case 'n': if(nflg || Nflg) 
				  {
					cerr << "multiple use of options -n/-N not allowed\n";
					return(4);
				  }
				  nflg = true;
				  if(argv[i][2])
				  {
					file = argv[i] + 2;
				  }
				  else
				  {
					if((i+1 < argc) && (argv[i+1][0] != '-'))
					{	
						i++;
						file = argv[i];
					}
				  }
				  if(file)
				  {
					lownetfile = new char [strlen(file) + 2];
					strcpy(lownetfile,file);
				  }
				  break;
		case 'N': if(nflg || Nflg)
				  {
					cerr << "multiple use of options -n/-N not allowed\n";
					return(4);
				  }
				  Nflg = true;
				  break;
		case 'a': if(aflg || Aflg) 
				  {
					cerr << "multiple use of options -a/-A not allowed\n";
					return(4);
				  }
				  aflg = true;
				  if(argv[i][2])
				  {
					file = argv[i] + 2;
				  }
				  else
				  {
					if((i+1 < argc) && (argv[i+1][0] != '-'))
					{	
						i++;
						file = argv[i];
					}
				  }
				  if(file)
				  {
					analysefile = new char [strlen(file) + 2];
					strcpy(analysefile,file);
				  }
				  break;
		case 'A': if(aflg || Aflg)
				  {
					cerr << "multiple use of options -a/-A not allowed\n";
					return(4);
				  }
				  Aflg = true;
				  break;
		case 's': if(sflg || Sflg) 
				  {
					cerr << "multiple use of options -s/-S not allowed\n";
					return(4);
				  }
				  sflg = true;
				  if(argv[i][2])
				  {
					file = argv[i] + 2;
				  }
				  else
				  {
					if( (i+1 < argc) && (argv[i+1][0] != '-'))
					{	
						i++;
						file = argv[i];
					}
				  }
				  if(file)
				  {
					statefile = new char [strlen(file) + 2];
					strcpy(statefile,file);
				  }
				  break;
		case 'S': if(sflg || Sflg)
				  {
					cerr << "multiple use of options -s/-S not allowed\n";
					return(4);
				  }
				  Sflg = true;
				  break;
		case 'y': if(yflg || Yflg) 
				  {
					cerr << "multiple use of options -y/-Y not allowed\n";
					return(4);
				  }
				  yflg = true;
				  if(argv[i][2])
				  {
					file = argv[i] + 2;
				  }
				  else
				  {
					if((i+1 < argc) && (argv[i+1][0] != '-'))
					{	
						i++;
						file = argv[i];
					}
				  }
				  if(file)
				  {
					symmfile = new char [strlen(file) + 2];
					strcpy(symmfile,file);
				  }
				  break;
		case 'Y': if(yflg || Yflg)
				  {
					cerr << "multiple use of options -y/-Y not allowed\n";
					return(4);
				  }
				  Yflg = true;
				  break;
		case 'p': if(pflg || Pflg) 
				  {
					cerr << "multiple use of options -p/-P not allowed\n";
					return(4);
				  }
				  pflg = true;
				  if(argv[i][2])
				  {
					file = argv[i] + 2;
				  }
				  else
				  {
					if((i+1 < argc) && (argv[i+1][0] != '-'))
					{	
						i++;
						file = argv[i];
					}
				  }
				  if(file)
				  {
					pathfile = new char [strlen(file) + 2];
					strcpy(pathfile,file);
				  }
				  break;
		case 'P': if(pflg || Pflg)
				  {
					cerr << "multiple use of options -p/-P not allowed\n";
					return(4);
				  }
				  Pflg = true;
				  break;
		case 'f':
		case 'm':
		case 'g': graphformat = argv[i][1];
				  if(gmflg || GMflg) 
				  {
					cerr << "multiple use of options -g/-m-f/-G/-M/-F not allowed\n";
					return(4);
				  }
				  gmflg = true;
				  if(argv[i][2])
				  {
					file = argv[i] + 2;
				  }
				  else
				  {
					if((i+1 < argc) &&(argv[i+1][0] != '-'))
					{	
						i++;
						file = argv[i];
					}
				  }
				  if(file)
				  {
					graphfile = new char [strlen(file) + 2];
					strcpy(graphfile,file);
				  }
				  break;
		case 'F':
		case 'M':
		case 'G': graphformat = tolower(argv[i][1]);
				  if(gmflg || GMflg)
				  {
					cerr << "multiple use of options -g/-m-f/-G/-M/-F not allowed\n";
					return(4);
				  }
				  GMflg = true;
				  break;
		default: cerr << "unrecognised option: -" << argv[i][2] << "\n";
				 return(4);
		}
	}
	else
	{
		// argument without option - must be net file;
		if(netfile)
		{
			cerr << "multiple net file argument\n";
			return(4);
		}
		netfile = new char[strlen(argv[i])+2 ];
		netbasename = new char [strlen(argv[i]) + 2];
		strcpy(netfile,argv[i]);
		strcpy(netbasename,argv[i]);
		for(h=strlen(netbasename);;h--)
		{
			if(netbasename[h] == '.')
			{	
				netbasename[h] = '\0';
				break;
			}
			if(h == 0) break;
		}
	}
  }
  // all options processed, now standard names for omitted file options
  if(!netbasename)
  {
	netbasename = new char[ strlen("unknown_net") + 2];
	strcpy(netbasename,"unknown_net");
  }
  if(nflg && !lownetfile)
  {	
	lownetfile = new char [strlen(netbasename) + 7];
	strcpy(lownetfile,netbasename);
	strcpy(lownetfile+strlen(netbasename),".llnet");
  }
  if(aflg && !analysefile)
  {	
	analysefile = new char [strlen(netbasename) + 7];
	strcpy(analysefile,netbasename);
	strcpy(analysefile+strlen(netbasename),".task");
  }
  if(sflg && !statefile)
  {	
	statefile = new char [strlen(netbasename) + 8];
	strcpy(statefile,netbasename);
	strcpy(statefile+strlen(netbasename),".state");
  }
  if(yflg && !symmfile)
  {	
	symmfile = new char [strlen(netbasename) + 7];
	strcpy(symmfile,netbasename);
	strcpy(symmfile+strlen(netbasename),".symm");
  }
  if(pflg && !pathfile)
  {	
	pathfile = new char [strlen(netbasename) + 7];
	strcpy(pathfile,netbasename);
	strcpy(pathfile+strlen(netbasename),".path");
  }
  if(gmflg && !graphfile)
  {	
	graphfile = new char [strlen(netbasename) + 8];
	strcpy(graphfile,netbasename);
	strcpy(graphfile+strlen(netbasename),".graph");
  }

  // 2. Initialisierung
  NonEmptyHash = 0;
	Edges = 0;
  try {
  HashTable = new Decision * [HASHSIZE];
	}
	catch(overflow)
	{
		char mess[] = "\nhash table too large!\n";
		//write(2,mess,sizeof(mess));
		cerr << mess;
		_exit(2);
	}
  for(i=0;i < HASHSIZE;i++)
  {
	  HashTable[i] = (Decision *) 0;
    }
	try{
		PlaceTable = new SymbolTab(65536);
		TransitionTable = new SymbolTab(65536);
	}
	catch(overflow)
	{
		char mess[] = "\nnot enough space to read net\n";
		//write(2,mess,sizeof(mess));
		cerr << mess;
		_exit(2);
	}
  try{
	  readnet();
	  removeisolated();
     }
  catch(overflow)
  {
	char mess [] = "\nnot enough space to store net\n";
	//write(2,mess,sizeof(mess));
	cerr << mess;
	_exit(2);
  }
  delete PlaceTable;
  delete TransitionTable;

  for(i=0; i < Places[0]->cnt;i++)
    {
      Places[i] -> set_hash(rand());
    }
  cout << Places[0]->cnt << " Places\n";
  cout << Transitions[0]->cnt << " Transitions\n";
  if(Nflg) printnet();
  if(nflg)
  {
	_IO_ostream_withassign tmpcout;
	ofstream lownetstream(lownetfile);
	if(!lownetstream)
	{
		cerr << "Cannot open net output file: " << lownetfile <<
		"\nno output written";
    }
	else
	{
		tmpcout = cout;
		cout = lownetstream;
		printnet();
		cout = tmpcout;
	}
  }
		

#ifdef SYMMETRY
  try{
	if(SYMMINTEGRATION == 1 || SYMMINTEGRATION == 3)
	{
		ComputeSymmetries();
	}
	else
	{
		ComputePartition();
	}
  }
  catch(overflow)
  {
	char mess [] = "\nnot enough space to store generating set for symmetries!\ntry again without use of symmetries!\n";
	//write(2,mess,sizeof(mess));
	cerr << mess;
	_exit(2);
  }
#endif
	try{
#ifdef NONE
	return 0;
#endif
#ifdef MODELCHECKING
#ifdef STUBBORN
  sortscapegoats();
#endif
return modelcheck();
#endif
#ifdef REVERSIBILITY
return reversibility();
#endif
#ifdef HOME
return home();
#endif
#ifdef FINDPATH
find_path();
return 0;
#endif
#ifndef MODELCHECKING
return  1 - GRAPH();
#endif
}
catch(overflow)
{
	//char mess [] = "memory exhausted\n";
	//cerr << mess;
	_exit(2);
}
}
catch(overflow)
{
	char mess [] = "memory exhausted\n";
	cerr << mess;
	_exit(2);
}
}



void removeisolated()
{
	unsigned int i,j;

	Place * p;

	i=0;
	while(i<Places[0]->cnt)
	{
		if(Places[i]->references == 0) // Place isolated
		{
			p = Places[Places[0]->cnt - 1];
			Places[Places[0]->cnt - 1] = Places[i];
			Places[i] = p;
			Places[0]->cnt --;
		}
		else
		{
			i++;
		}
	}
}


